//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_plots   1
#property indicator_label1  "dema ha smoothed"
#property indicator_type1   DRAW_COLOR_CANDLES
#property indicator_color1  clrLimeGreen,clrPaleVioletRed
#property indicator_width1  2

//
//
//
//
//

input double iPeriod      = 5;      // Price smoothing
input double rPeriod      = 12;     // Result smoothing
input bool   BetterFormula = false; // Use "better formula"

//
//
//
//
//

double dhah[];
double dhal[];
double dhao[];
double dhac[];
double colorBuffer[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int OnInit()
{
   SetIndexBuffer(0,dhao,INDICATOR_DATA);
   SetIndexBuffer(1,dhah,INDICATOR_DATA);
   SetIndexBuffer(2,dhal,INDICATOR_DATA);
   SetIndexBuffer(3,dhac,INDICATOR_DATA);
   SetIndexBuffer(4,colorBuffer,INDICATOR_COLOR_INDEX); 
   IndicatorSetString(INDICATOR_SHORTNAME,"Dema heiken ashi("+string(iPeriod)+","+(string)(rPeriod)+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int bars;
double work[][4];
#define _high  0
#define _low   1
#define _open  2
#define _close 3

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{
   bars = rates_total;
   if (ArrayRange(work,0)!=rates_total) ArrayResize(work,rates_total);
   
   //
   //
   //
   //
   //
   
   
   for (int i=(int)MathMax(prev_calculated-1,1); i<rates_total; i++)
   {
      double maOpen  = iDema(open[i] ,iPeriod,i,0);
      double maClose = iDema(close[i],iPeriod,i,1);
      double maLow   = iDema(low[i]  ,iPeriod,i,2);
      double maHigh  = iDema(high[i] ,iPeriod,i,3);
   
      //
      //
      //
      //
      //
        
         double haClose,haOpen,haHigh,haLow;
         if (BetterFormula) {
               if (maHigh!=maLow)
                     haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
               else  haClose = (maOpen+maClose)/2; }
         else        haClose = (maOpen+maHigh+maLow+maClose)/4;
                     haOpen   = (work[i-1][_open]+work[i-1][_close])/2;
                     haHigh   = MathMax(maHigh, MathMax(haOpen,haClose));
                     haLow    = MathMin(maLow,  MathMin(haOpen,haClose));

         if (haOpen<haClose) { work[i][_high]=haLow;  work[i][_low]=haHigh; } 
         else                { work[i][_high]=haHigh; work[i][_low]=haLow;  } 
                               work[i][_open] =haOpen;
                               work[i][_close]=haClose;
   
      //
      //
      //
      //
      //
        
         dhah[i] = iDema(work[i][_high]  ,rPeriod,i,4);
         dhal[i] = iDema(work[i][_low]   ,rPeriod,i,5);
         dhao[i] = iDema(work[i][_open]  ,rPeriod,i,6);
         dhac[i] = iDema(work[i][_close] ,rPeriod,i,7);
         if (dhac[i]>dhao[i]) colorBuffer[i] = 0;
         if (dhac[i]<dhao[i]) colorBuffer[i] = 1;
   }      
   return(rates_total);
}



//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workDema[][16];
#define _ema1 0
#define _ema2 1

double iDema(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workDema,0)!= bars) ArrayResize(workDema,bars); instanceNo*=2; 

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workDema[r][_ema1+instanceNo] = workDema[r-1][_ema1+instanceNo]+alpha*(price                        -workDema[r-1][_ema1+instanceNo]);
          workDema[r][_ema2+instanceNo] = workDema[r-1][_ema2+instanceNo]+alpha*(workDema[r][_ema1+instanceNo]-workDema[r-1][_ema2+instanceNo]);
   return(workDema[r][_ema1+instanceNo]*2.0-workDema[r][_ema2+instanceNo]);
}  
